# -*- coding: utf-8 -*-
from setuphelpers import *

r"""
Usable WAPT package functions: install(), uninstall(), session_setup(), audit(), update_package()
{
   "key":"GrampsAIO64 5.2.3",
   "name":"GrampsAIO64",
   "version":"5.2.3",
   "install_date":"",
   "install_location":"",
   "uninstall_string":"\"C:\\Program Files\\GrampsAIO64-5.2.3\\uninstall.exe\" /AllUsers",
   "publisher":"The Gramps project",
   "system_component":0,
   "win64":true
  }

"""
# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls


def install():
    # Declaring local variables
    bin_name = glob.glob("GrampsAIO-*.exe")[0]


    for to_uninstall in installed_softwares("GrampsAIO64"):
        version = to_uninstall["version"]
        if Version(version, 4) < Version(control.get_software_version(), 4) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], version))
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]))
            wait_uninstallkey_absent(to_uninstall["key"])

    # Extraire la version du nom du fichier
    version = bin_name.split('-')[1]

    # Construire la clé dynamique
    key = f"GrampsAIO64 {version}"
    # Installing the software
    install_exe_if_needed(
        bin_name,
        silentflags="/S /AllUSERS",
        key=key,
        min_version=control.get_software_version(),
        get_version=get_version,
        timeout=600,
    )


def get_version(app_registry_dict):
    return app_registry_dict["version"].split("-")[0]

